Package net.sf.saxon.expr.sort

## Interface AtomicComparer

- All Known Implementing Classes:
    `AtomicSortComparer`, `CalendarValueComparer`, `CodepointCollatingComparer`, `CollatingAtomicComparer`, `ComparableAtomicValueComparer`, `DecimalSortComparer`, `DescendingComparer`, `DoubleSortComparer`, `EmptyGreatestComparer`, `EqualityComparer`, `EquivalenceComparer`, `GenericAtomicComparer`, `NumericComparer`, `NumericComparer11`, `TextComparer`, `UntypedNumericComparer`

      public interface AtomicComparer

  Interface representing an object that can be used to compare two XPath atomic values for equality or for ordering.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `int` | `compareAtomicValues​(AtomicValue a, AtomicValue b)` | Compare two AtomicValue objects according to the rules for their data type.
    `boolean` | `comparesEqual​(AtomicValue a, AtomicValue b)` | Compare two AtomicValue objects for equality according to the rules for their data type.
    `StringCollator` | `getCollator()` | Get the collation used by this AtomicComparer if any
    `AtomicComparer` | `provideContext​(XPathContext context)` | Supply the dynamic context in case this is needed for the comparison
    `java.lang.String` | `save()` | Create a string representation of this AtomicComparer that can be saved in a compiled package and used to reconstitute the AtomicComparer when the package is reloaded

- - ### Method Detail

    - #### getCollator

          StringCollator getCollator()

      Get the collation used by this AtomicComparer if any
      Returns:
        the collation used for comparing strings, or null if not applicable

    - #### provideContext

          AtomicComparer provideContext​(XPathContext context)

      Supply the dynamic context in case this is needed for the comparison
      Parameters:
        `context` - the dynamic evaluation context
      Returns:
        either the original AtomicComparer, or a new AtomicComparer in which the context is known. The original AtomicComparer is not modified

    - #### compareAtomicValues

          int compareAtomicValues​(AtomicValue a,
                                  AtomicValue b)
                           throws NoDynamicContextException

      Compare two AtomicValue objects according to the rules for their data type. UntypedAtomic values are compared as if they were strings; if different semantics are wanted, the conversion must be done by the caller.
      Parameters:
        `a` - the first object to be compared. It is intended that this should be an instance of AtomicValue, though this restriction is not enforced. If it is a StringValue, the collator is used to compare the values, otherwise the value must implement the java.util.Comparable interface.
        `b` - the second object to be compared. This must be comparable with the first object: for example, if one is a string, they must both be strings.
      Returns:
        <0 if a<b, 0 if a=b, >0 if a>b
      Throws:
        `java.lang.ClassCastException` - if the objects are not comparable
        `NoDynamicContextException` - if this comparer required access to dynamic context information, notably the implicit timezone, and this information is not available. In general this happens if a context-dependent comparison is attempted at compile-time, and it signals the compiler to generate code that tries again at run-time.

    - #### comparesEqual

          boolean comparesEqual​(AtomicValue a,
                                AtomicValue b)
                         throws NoDynamicContextException

      Compare two AtomicValue objects for equality according to the rules for their data type. UntypedAtomic values are compared by converting to the type of the other operand.
      Parameters:
        `a` - the first object to be compared.
        `b` - the second object to be compared.
      Returns:
        true if the values are equal, false if not
      Throws:
        `java.lang.ClassCastException` - if the objects are not comparable
        `NoDynamicContextException`

    - #### save

          java.lang.String save()

      Create a string representation of this AtomicComparer that can be saved in a compiled package and used to reconstitute the AtomicComparer when the package is reloaded
      Returns:
        a string representation of the AtomicComparer